package Swatout;
use strict;

# Swat 2.1 
# Last updated on 12/10/97
# Copyright (c) by Chris Kight 1997

my $self = ( );

sub new {
   my $proto = shift;
   my $class = ref($proto) || $proto;
   $self = { 
     g		=> shift,
     form	=> shift,
     files	=> shift,
     counter	=> shift,
     "time"     => shift,
     top 	=> '',		# Block above the results
     res	=> '',		# Results definition
     bottom	=> '',		# Block below the results
     sizeofcounter => '',  
   };
   bless ($self, $class);
   return $self;
}

my $pages;
my $sizeofcounter;

sub return_html {
   my $self = shift;

   foreach my $tmpcount (keys %{$self->{counter}}) {
      if ($self->{counter}{$tmpcount}) {
         $self->{sizeofcounter}++;
      }
   }

   $self->_parseoutput();       # Parse the output

   my $num = 1;	   # Counter for results before we start printing to the screen
   my $resinp = 0; # Counter for how many results we've printed to the screen
   my $firstres = ($self->{form}{p} * $self->{form}{rpp}) - $self->{form}{rpp};
		   # Page * Results Per Page - Results Per Page 
		   # equals the first result on the current page

   print $self->{results}[0];

   foreach my $file (sort ByValue keys %{$self->{counter}}) {
       if ($self->{counter}{$file}) {
	   if ($num <= $firstres) {
	       $num++;
	   } else {
	       if ($resinp < $self->{form}{rpp}) {
		   # the Res definition is uses to print the results
		   my $res = $self->{results}[1];
		   $res =~ s/\{Link\}/<a href=\"$file\">/;
		   $res =~ s/\{Title\}/${$self->{files}{$file}{title}}<\/a>\n/;
                   $res =~ s/\{Desc\}/${$self->{files}{$file}{desc}}<\/a>\n/;
	           $res =~ s/\{Value\}/$self->{counter}{$file}\n/;
	           print $res;
                   $resinp++;	# Counts how many we've printed
               }  
           }
       }
   }

   print $self->{results}[2];	# We're done, print the bottom

   if ($self->{g}{heart} == 1) {
	print 'SWAT v2.1 by <a href="http://corona.dnv.soltec.net/swat">Chris Knight<\/a><br>\n';
   } elsif ($self->{g}{heart} == 2) {
	print '<a href="http://corona.dnv.soltec.net"><img src="'.$self->{g}{searchg}.'" border=0></a><br>';
   }
}

sub ByValue {	# Sort counter by the value contained in it
   my $aval = $self->{counter}{$a};
   my $bval = $self->{counter}{$b};
   $bval <=> $aval;
}

sub _parseoutput {
    my $self = shift;

    unless (open(RESULT,"$self->{g}{results}")) { die "Could not open ".$self->{g}{results}; }
    my @results = <RESULT>;
    close (RESULT);
    
    foreach my $result (@results) {
	$result =~ s/\#.*//;	
    }

    my $results = join('',@results);


    my $url = '';
    foreach my $keys (keys %{$self->{form}}) {
	$url = $url."$keys=".$self->{form}{$keys}."&" unless ($keys eq "p");
    }
    $url = $self->{g}{cgiurl}.'?'.$url;

    my $extref = { 
	"time"          => $self->{"time"}, 
	"form"          => $self->{form}, 
	"g"             => $self->{g}, 
	"sizeofcounter" => $self->{sizeofcounter}, 
	"url"           => $url,
    };

    my @directives = $results =~ m/{.*?}/g;

    for (@directives) {
	$_ =~ /{([^:]*)(.*)}/;
	my $name = $1;
	my $param = $2;
	my $params = [ split(/::/,$param) ];
	shift(@$params);

	next if ($name eq "Link" || $name eq "Title" || $name eq "Desc" || $name eq "Value");

	eval {
	    require $name.".pm"; # Skip over the directive if no module exists
	};
	next if $@;

	my $obj = $name->new($extref,$params);
	my $replacement = $obj->replace();
	$results =~ s/{$name.*?}/$replacement/g;
    }

    @{$self->{results}} = split(/\|\|/,$results);   # Split our results buffer
}
1;

