package Flat;
use strict;

sub new {
   my $proto = shift;
   my $class = ref($proto) || $proto;
   my $self = {
      indexfile => shift,
      append    => shift,
      contents  => '',
      files     => { },
   };
   bless ($self, $class);
   return $self;
}

my @files = ();
my $numwcall = 0;

sub openr {
   my $self = shift;
   unless(open(INDEX, $self->{indexfile})) { die "Could not open index $self->{indexfile} for reading"; }
   my @contents = <INDEX>;
   close(INDEX);
   $self->{contents} = join('',@contents);
   $self->parse_index();
}

sub openw {
   my $self = shift;
   if ($self->{append} == 1) {
       unless(open(INDEX,">>$self->{indexfile}")) {die "Could not open index $self->{indexfile} for appending"; }
       $self->parse_index();
   } elsif ($self->{append} == 0) {
       unless(open(INDEX,">$self->{indexfile}")) { die "Could not open index $self->{indexfile} for overwriting"; }
   } else {
       die "Illegal append mode $self->{append}\n"; 
   }
}

sub closew {
   my $self = shift;
   close(INDEX);
}

sub closer {
    my $self = shift;
    close(INDEX);
}

sub exists {
    my $self = shift;
    my $entry = shift;
    return 1 if (exists ($self->{files}{$entry}));
    return 0;
}

sub write {   
   my $self = shift;
   my $entry = shift;
   my $hashref = shift;
   print INDEX $entry."|".${$hashref->{title}}."|".${$hashref->{key}}."|".${$hashref->{desc}}."|".${$hashref->{body}}."||";
}

sub parse_index {
   my $self = shift;
   my $index;
   foreach $index (split('\|\|',$self->{contents})) {
      my ($curfile,$title,$key,$desc,$body) = split('\|',$index);
      # Split each index entry, entry fields are split with a |
      $self->{files}->{$curfile}{title} = $title;
      $self->{files}->{$curfile}{key} = $key;
      $self->{files}->{$curfile}{desc} = $desc;
      $self->{files}->{$curfile}{body} = $body;
      push(@files,$curfile);
      # Keep a global copy of the files we're indexing.
   }
}

sub get_files {
   my $self = shift;
   pop(@files);
   return @files;
   # Returns the array of the files we've indexed.
}
         
sub get_entry {
    my $self = shift;
    my $entry = shift;
    return $self->{files}{$entry};
}

sub get_contents {
   my $self = shift;
   return $self->{files};
   # The hash containing all the information for the files.
   # in the $files->{filename}{key},{desc},{title}
   # Note that no real data is being passed, but just references
}   
1;

